# coding: utf-8

"""
    FDS API

    API for Flight Dynamics System

    The version of the OpenAPI document: 1.1.0
    Contact: contact@exotrail.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from spacetower_python_client.models.tle import TLE
from typing import Optional, Set
from typing_extensions import Self

class OrbitalStateCreationRequestDto(BaseModel):
    """
    OrbitalStateCreationRequestDto
    """ # noqa: E501
    covariance_matrix_id: Optional[StrictStr] = Field(default=None, alias="covarianceMatrixId")
    orbit_id: Optional[StrictStr] = Field(default=None, description="Orbit ID (osculating or mean) is mandatory if no TLE is provided.", alias="orbitId")
    propagation_context_id: StrictStr = Field(alias="propagationContextId")
    spacecraft_id: StrictStr = Field(alias="spacecraftId")
    tle: Optional[TLE] = None
    __properties: ClassVar[List[str]] = ["covarianceMatrixId", "orbitId", "propagationContextId", "spacecraftId", "tle"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OrbitalStateCreationRequestDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of tle
        if self.tle:
            _dict['tle'] = self.tle.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OrbitalStateCreationRequestDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "covarianceMatrixId": obj.get("covarianceMatrixId"),
            "orbitId": obj.get("orbitId"),
            "propagationContextId": obj.get("propagationContextId"),
            "spacecraftId": obj.get("spacecraftId"),
            "tle": TLE.from_dict(obj["tle"]) if obj.get("tle") is not None else None
        })
        return _obj


