# coding: utf-8

"""
    FDS API

    API for Flight Dynamics System

    The version of the OpenAPI document: 1.1.0
    Contact: contact@exotrail.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class RadarTelemetryDto(BaseModel):
    """
    RadarTelemetryDto
    """ # noqa: E501
    azimuth_standard_deviation: Union[StrictFloat, StrictInt] = Field(description="Units: [deg]", alias="azimuthStandardDeviation")
    dates: List[StrictStr] = Field(description="List of UTC dates")
    elevation_standard_deviation: Union[StrictFloat, StrictInt] = Field(description="Units: [deg]", alias="elevationStandardDeviation")
    ground_station_id: StrictStr = Field(alias="groundStationId")
    id: Optional[StrictStr] = None
    measurements: List[List[Union[StrictFloat, StrictInt]]] = Field(description="Array of double: range, range rate, azimuth, elevation. Units: [m], [m/s], [deg], [deg]")
    range_rate_standard_deviation: Union[StrictFloat, StrictInt] = Field(description="Units: [m/s]", alias="rangeRateStandardDeviation")
    range_standard_deviation: Union[StrictFloat, StrictInt] = Field(description="Units: [m]", alias="rangeStandardDeviation")
    two_way_measurement: StrictBool = Field(alias="twoWayMeasurement")
    __properties: ClassVar[List[str]] = ["azimuthStandardDeviation", "dates", "elevationStandardDeviation", "groundStationId", "id", "measurements", "rangeRateStandardDeviation", "rangeStandardDeviation", "twoWayMeasurement"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RadarTelemetryDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RadarTelemetryDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "azimuthStandardDeviation": obj.get("azimuthStandardDeviation"),
            "dates": obj.get("dates"),
            "elevationStandardDeviation": obj.get("elevationStandardDeviation"),
            "groundStationId": obj.get("groundStationId"),
            "id": obj.get("id"),
            "measurements": obj.get("measurements"),
            "rangeRateStandardDeviation": obj.get("rangeRateStandardDeviation"),
            "rangeStandardDeviation": obj.get("rangeStandardDeviation"),
            "twoWayMeasurement": obj.get("twoWayMeasurement")
        })
        return _obj


