# coding: utf-8

"""
    FDS API

    API for Flight Dynamics System

    The version of the OpenAPI document: 1.1.0
    Contact: contact@exotrail.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class UkfOrbitDeterminationInputDto(BaseModel):
    """
    UkfOrbitDeterminationInputDto
    """ # noqa: E501
    configuration_id: StrictStr = Field(alias="configurationId")
    estimated_results_min_step: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Minimum step for the estimated results. Unit: s.", alias="estimatedResultsMinStep")
    initial_orbital_state_id: StrictStr = Field(alias="initialOrbitalStateId")
    parameter_estimation_request_ids: Optional[List[StrictStr]] = Field(default=None, alias="parameterEstimationRequestIds")
    roadmap_id: Optional[StrictStr] = Field(default=None, alias="roadmapId")
    telemetry_id: StrictStr = Field(alias="telemetryId")
    __properties: ClassVar[List[str]] = ["configurationId", "estimatedResultsMinStep", "initialOrbitalStateId", "parameterEstimationRequestIds", "roadmapId", "telemetryId"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UkfOrbitDeterminationInputDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UkfOrbitDeterminationInputDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "configurationId": obj.get("configurationId"),
            "estimatedResultsMinStep": obj.get("estimatedResultsMinStep"),
            "initialOrbitalStateId": obj.get("initialOrbitalStateId"),
            "parameterEstimationRequestIds": obj.get("parameterEstimationRequestIds"),
            "roadmapId": obj.get("roadmapId"),
            "telemetryId": obj.get("telemetryId")
        })
        return _obj


